"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var createBlockingWriter = function createBlockingWriter(stream) {
  return {
    write: function write(message) {
      stream.write(message + '\n');
    }
  };
};

var createNodeWriter = function createNodeWriter() {
  // eslint-disable-next-line no-process-env
  var targetStream = (process.env.ROARR_STREAM || 'STDOUT').toUpperCase();
  var stream = targetStream.toUpperCase() === 'STDOUT' ? process.stdout : process.stderr;
  return createBlockingWriter(stream);
};

var _default = createNodeWriter;
exports.default = _default;
//# sourceMappingURL=createNodeWriter.js.map